<?php
/*------------------------------------------------------------------------
# mod_vtem_mp3 - VTEM MP3 Module
# ------------------------------------------------------------------------
# author Nguyen Van Tuyen
# copyright Copyright (C) 2010 VTEM.NET. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.vtem.net
# Technical Support: Forum - http://vtem.net/forum.html
-------------------------------------------------------------------------*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
class modVtemMp3Helper{
	public function __construct($module, $params) {
		// initialize config array
		$this->config = array();
		$this->config['modlayout'] = $params->get('modlayout', 0);
		$this->config['width'] = $params->get('width', '260px');
		$this->config['height'] = $params->get('height', 0);
		$this->config['modstyle'] = $params->get('modstyle', 'style11');
		$this->config['mp3list'] = $params->get('mp3list', 1);
		$this->config['defaultitem'] = $params->get('defaultitem', 1);
		$this->config['autoplay'] = $params->get('autoplay', 1);
		$this->config['mute'] = $params->get('mute', 0);
		$this->config['volume'] = $params->get('volume', 0.8);
		$this->config['loop'] = $params->get('loop', 1);
		$this->config['shuffle'] = $params->get('shuffle', 0);
		$this->config['jquery'] = $params->get('jquery', 1);
		$this->config['css'] = $params->get('css', '');
		$this->config['moduleclass_sfx'] = $params->get('moduleclass_sfx', '');
		$this->config['module_id'] = 'vtemmp3id'.$module->id;
		$this->config['dataSource'] = $params->get('dataSource', 1);
		$this->config['mp3Path'] = modVtemMp3Helper::cleanDir($params->get('mp3Path', 'modules/mod_vtem_mp3/skin/mp3'));
		$this->config['sortCriteria'] = $params->get( 'sortCriteria', 0);
		$this->config['sortOrder'] = $params->get( 'sortOrder', 'asc');
		$this->config['sortOrderManual'] = $params->get( 'sortOrderManual', '');
		$this->config['mp3name'] = $params->get( 'mp3name', '');
		$this->config['mp3artist'] = $params->get( 'mp3artist', '');
		if (trim($this->config['sortOrderManual']) != "")
			$this->config['dmp3'] = explode(";", $this->config['sortOrderManual']);
		else
			$this->config['dmp3'] = modVtemMp3Helper::mp3List($this->config['mp3Path'], $this->config['sortCriteria'], $this->config['sortOrder']);
		
		// get the JSON tabs data
		$this->config['tabs_data'] = $params->get('tabs_data', '[]');
		$this->config['tabs_data'] = json_decode($this->config['tabs_data']);
	}
	// function to render module code
	public function render() {
		if(count($this->config['tabs_data']) == 0 && $this->config['dataSource']) {
			echo JText::_('MOD_VTEM_MP3_NO_ITEMS_TO_SHOW');
			return false;
		}
		// create arrays for the content
		$this->mp3_title = array();
		$this->mp3_free = array();
		$this->mp3_artist = array();
		$this->mp3_url = array();
		// get the user ID
		$user = JFactory::getUser();
		$registered_user = ($user->get('id', 0) != 0) ? true : false;
		// remove the unpublished or invisible for specified user tabs and put only necessary tabs
		for($i = 0; $i < count($this->config['tabs_data']); $i++) {
			if($this->config['tabs_data'][$i]->published == 1 && 
				($this->config['tabs_data'][$i]->access == 'public' || 
				($this->config['tabs_data'][$i]->access == 'registered' && $registered_user))) {
				$this->mp3_title[] = $this->config['tabs_data'][$i]->name;
				$this->mp3_free[] = $this->config['tabs_data'][$i]->type;
				$this->mp3_artist[] = $this->config['tabs_data'][$i]->image;
				$this->mp3_url[] = $this->config['tabs_data'][$i]->url;
			}
		}
		$document = JFactory::getDocument();
		$uri = JURI::getInstance();
		$document->addStyleSheet($uri->root().'modules/mod_vtem_mp3/skin/styles.css');
		if($this->config['jquery'] == 1) {
			$document->addScript($uri->root().'modules/mod_vtem_mp3/js/jquery-1.7.2.min.js');
		}
		
		$cssstyle = '#vtemmp3_container_'.$this->config['module_id'].'.vtem-audio{width:'.$this->config['width'].';}';
		if($this->config['height'] == 0){
			$cssstyle .= '#vtemmpl3list'.$this->config['module_id'].'{height:auto;}';
		}else{
			$cssstyle .= '#vtemmpl3list'.$this->config['module_id'].'{height:'.$this->config['height'].'px; overflow:auto; overflow-x:hidden;}';
		}
		if($this->config['mp3list'] == 0){
			$cssstyle .= '#vtemmpl3list'.$this->config['module_id'].'{display:none !important;}';
		}
		$cssstyle .= $this->config['css'];
		$document->addStyleDeclaration( $cssstyle );
		
        if($this->config['dataSource'])
			require(JModuleHelper::getLayoutPath('mod_vtem_mp3', 'default'));
		else
			require(JModuleHelper::getLayoutPath('mod_vtem_mp3', 'fdefault'));
	}
	public function mp3List ($directory, $sortcriteria, $sortorder) {
	    $results = array();
	    $handler = opendir($directory);
			$i = 0;
	    while ($file = readdir($handler)) {
	        if ($file != '.' && $file != '..' && modVtemMp3Helper::isMp3($file)) {
						$results[$i][0] = $file;
						$results[$i][1] = filemtime($directory . "/" .$file);
						$i++;
					}
	    }
	    closedir($handler);
			//these lines sort the contents of the directory by the date
			// Obtain a list of columns
			foreach($results as $res) {
				if ($sortcriteria == 0 ) $sortAux[] = $res[0];
				else $sortAux[] = $res[1];
			}
			if ($sortorder == 0) {
				array_multisort($sortAux, SORT_ASC, $results);
			} elseif ($sortorder == 2) {
				srand((float)microtime() * 1000000);
				shuffle($results);
			} else {
				array_multisort($sortAux, SORT_DESC, $results);
			}
			foreach($results as $res) {
				$sorted_results[] = $res[0];
			}
	    return $sorted_results;
	}

	public function isMp3($file) {
		$imagetypes = array(".mp3", ".m4v", ".ogv", ".webm");
		$extension = substr($file,strrpos($file,"."));
		if (in_array($extension, $imagetypes)) return true;
		else return false;
	}

	public function cleanDir($dir) {
		if (substr($dir, -1, 1) == '/')
			return $dir;
		else
			return $dir . "/";
	}

}
